local ldb_tip, scanning
local list    = ""
local item    = {}
local f   = CreateFrame("Button", "Junkit")
local ldb_obj = LibStub("LibDataBroker-1.1"):NewDataObject("Junkit", {
	icon = "Interface\\Icons\\Ability_Kick.png",
	label = "Junkit",
	type = "data source"
})

JunkitSV = JunkitSV or ""

f:RegisterEvent"PLAYER_LOGIN"
f:RegisterEvent"BAG_UPDATE"
f:RegisterEvent"MERCHANT_CLOSED"
f:RegisterEvent"MERCHANT_UPDATE"
f:RegisterEvent"TRADE_CLOSED"
f:RegisterEvent"MAIL_CLOSED"
f:RegisterEvent"AUCTION_HOUSE_CLOSED"

f:SetScript("OnEvent", function(_, event, ...) f[event](...) end)

local function inform(text)
	DEFAULT_CHAT_FRAME:AddMessage("|cffffd700Junkit:|r |cffeeeeee"..text.."|r")
end

local function cash_to_string(cash)
	if not cash then return "?" end
	return  GetCoinTextureString(cash)
end

local function scan()
--	inform('Scanning...')
	if scanning then
		inform("The anti-flooding system has engaged, the information currently being shown is not correct.")
		inform("Please DO NOT delete any items until you've done a UI reload or logged out and then back in.")
		inform("This means that a mod and/or a bug has caused BAG_UPDATE events to occur too frequently.")
		inform("Please report this issue to me and the mod responsible (if you know which), thanks!")

		return
	end

	scanning = true
        item = {}

	for bag = 0, NUM_BAG_FRAMES do
		for slot = 1, GetContainerNumSlots(bag) do
			local _, count, _, _, _, _, link = GetContainerItemInfo(bag, slot)
--			local quality, iprice

			if link then
				local _, _, quality, _, _, _, _, _, _, _, iprice = GetItemInfo(link)
			        local id     = GetContainerItemID(bag, slot)
--				local id      = tonumber(link:match("item:(%d+)"))

				if not list:find("-"..id) and (JunkitSV:find("-"..id) or exceptions_mode or (quality or 1) == 0) then
					local price = (iprice or 0) * (count or 0)

					if price > 0 and (not item.price or price < item.price) then
						item.price = price
						item.link  = link
						item.count = count
						item.bag   = bag
						item.slot  = slot
						item.id    = id
					end
				end
			end
		end
	end

	scanning = nil
	price    = nil

	ldb_obj.text = item.link and item.link..(item.count > 1 and "x"..item.count or "").." "..cash_to_string(item.price) or "No Items Found"
end

local function reset_list()
	list = ""
	item = {}

	scan()
	ldb_obj.OnTooltipShow(ldb_tip)
end

function ldb_obj.OnTooltipShow(tip)
	if not ldb_tip then ldb_tip = tip end

	tip:ClearLines()

	tip:AddLine("Junkit:")
	tip:AddLine(" ")

	if scanning then
		tip:AddLine("|cffeeeeeePlease wait, Junkit is currently scanning your bags.|r")
		return
	end

	if item.link then
		tip:AddLine("Item: "..item.link.."|cffeeeeee.|r")

		if not exceptions_mode then
			tip:AddLine("Type: |cffeeeeee"..(JunkitSV:find("-"..item.id) and "Exception" or "Trash")..".|r")
		end

		tip:AddLine("Count: |cffeeeeee"..item.count..".|r")
		tip:AddLine("Value: "..cash_to_string(item.price).."|cffeeeeee.|r")

	else
		tip:AddLine("Item: |cffeeeeeeNone available.|r")
	end

	if exceptions_mode then
		tip:AddLine(" ")
		tip:AddLine("Exceptions list management is active.")
	end

	tip:AddLine(" ")

	if item.link then
		tip:AddLine("|cff69b950Click:|r |cffeeeeeeTemporarily ignores this item.|r")
		tip:AddLine("|cff69b950Shift + Click:|r |cffeeeeee"..(exceptions_mode and (JunkitSV:find("-"..item.id) and "Removes the exception tag from" or "Adds an exception tag to").." this item.|r" or "|cffeeeeeeDestroys this item.|r"))
	end

	if item.link or (not item.link and list ~= "") then
		tip:AddLine("|cff69b950Alt + Click:|r |cffeeeeeeResets the temporary ignore list.|r")
	end

	tip:AddLine("|cff69b950Control + Click:|r |cffeeeeeeToggles exceptions management mode.|r")
	tip:Show()
end

function ldb_obj.OnClick()
	if scanning then
		inform("Please wait, Junkit is still scanning your bags.")
		return
	end

	if IsControlKeyDown() then
		exceptions_mode = not exceptions_mode

		reset_list()

	elseif IsAltKeyDown() then
		inform("The ignore list has been reset.")

		reset_list()

	elseif IsShiftKeyDown() and item.link then
		if exceptions_mode then
			JunkitSV = JunkitSV:find("-"..item.id) and JunkitSV:gsub("-"..item.id, "") or JunkitSV.."-"..item.id

			item = {}

			scan()
			ldb_obj.OnTooltipShow(ldb_tip)

		else inform("Dropping "..item.link.." worth "..cash_to_string(item.price)..".")
			if (GetContainerItemLink(item.bag, item.slot) == item.link) then
			   PickupContainerItem(item.bag, item.slot)
			   item = {}
			   DeleteCursorItem()
			else
			   inform('Item not where expected, rescanning, nothing dropped.')
                        end
			scan()
			ldb_obj.OnTooltipShow(ldb_tip)
		end

	elseif item.link then
		inform("Ignored "..item.link.." worth "..cash_to_string(item.price)..".")

		list = list.."-"..item.id
		item = {}

		scan()
		ldb_obj.OnTooltipShow(ldb_tip)
	end
end

f.MERCHANT_CLOSED      = scan
f.MERCHANT_UPDATE      = scan
f.PLAYER_LOGIN         = scan
f.BAG_UPDATE           = scan
f.TRADE_CLOSED         = scan
f.MAIL_CLOSED          = scan
f.AUCTION_HOUSE_CLOSED = scan

-- f.PLAYER_LOGIN()
--  check for GetItemPrice
-- do sv var. init here , safer
